import 'reflect-metadata';
export class Dynamic {
    constructor() {
        this.__dynamicCurrentPromise = null;
    }
    async get() {
        if (this.__dynamicCurrentPromise !== null && this.__dynamicCurrentPromise.constructor === Promise)
            await this.__dynamicCurrentPromise;
        return this;
    }
}
(function (Dynamic) {
    function Locked(target, propertyName, descriptor) {
        const isDynamicInstance = target instanceof Dynamic;
        const isAsyncMethod = Reflect.getMetadata("design:returntype", target, propertyName) === Promise;
        if (isDynamicInstance === true && isAsyncMethod === true) {
            const methodBackup = descriptor.value;
            descriptor.value = async (...args) => {
                this.__dynamicCurrentPromise = methodBackup.apply(this, ...args);
                await this.__dynamicCurrentPromise;
                this.__dynamicCurrentPromise = null;
            };
        }
    }
    Dynamic.Locked = Locked;
})(Dynamic || (Dynamic = {}));
