import { Urls } from './urls';
import { Utils } from './utils';
import { Thread } from './thread';
import { User, BasicUser, CurrentUser, Nickname } from './user';
export declare class FC {
    private static currentUserId;
    private static currentToken;
    static readonly Urls: typeof Urls;
    static readonly Utils: typeof Utils;
    static getUserData(id: number): Promise<User>;
    static getThreadData(id: number): Promise<Thread>;
    static getCurrentUserId(force_update?: boolean): Promise<number>;
    static getCurrentUser(): Promise<CurrentUser>;
    static getSecurityToken(): Promise<string>;
    static searchForPartialNickname(nicknameFragment: Nickname): Promise<BasicUser[]>;
}
