import { Dynamic } from './dynamic';
import { Post } from './post';
import { BasicUser } from './user';
export declare type PostCountByUser = Map<BasicUser, number>;
export declare class Thread extends Dynamic {
    readonly id: number;
    authorId: number;
    zoneId: number;
    title: string;
    creationDate: Date;
    postCount: number;
    get pageCount(): number;
    exists: boolean;
    error: string;
    static readonly DEFAULT_POSTS_PER_PAGE = 30;
    static readonly MAX_POSTS_PER_PAGE = 60;
    constructor(id: number, update?: boolean);
    private updateFromHTML;
    update(): Promise<this>;
    getWhoPosted(): Promise<PostCountByUser>;
    getPost(number: number): Promise<Post>;
    getMultiplePosts(numbers: number[]): Promise<Map<number, Post>>;
    getPostsInPage(pageNumber?: number, postsPerPage?: number, update?: boolean): Promise<Post[]>;
    getPostInRange(start?: number, end?: number, update?: boolean): Promise<Post[]>;
}
